<?php
function _galleryUpdate()
{
	global $objDatabase, $_ARRAYLANG;

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."module_gallery_pictures");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_gallery_pictures'));
		return false;
	}

	if (!in_array('catimg', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_gallery_pictures` ADD `catimg` SET( '0', '1' ) DEFAULT '0' NOT NULL AFTER `status`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "ALTER TABLE `".DBPREFIX."module_gallery_language`
		CHANGE `gallery_id` `gallery_id` int(10) unsigned NOT NULL default '0',
  		CHANGE `lang_id` `lang_id` int(10) unsigned NOT NULL default '0',
  		CHANGE `name` `name` set('name','desc') NOT NULL default ''";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "ALTER TABLE `".DBPREFIX."module_gallery_language_pics`
		CHANGE `picture_id` `picture_id` int(10) unsigned NOT NULL default '0',
  		CHANGE `lang_id` `lang_id` int(10) unsigned NOT NULL default '0',
  		CHANGE `name` `name` varchar(255) NOT NULL default '',
  		CHANGE `desc` `desc` varchar(255) NOT NULL default ''";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "ALTER TABLE `".DBPREFIX."module_gallery_votes`
		CHANGE `picid` `picid` int(10) unsigned NOT NULL default '0',
  		CHANGE `date` `date` int(14) unsigned NOT NULL default '0',
  		CHANGE `ip` `ip` varchar(15) NOT NULL default '',
  		CHANGE `md5` `md5` varchar(32) NOT NULL default '',
  		CHANGE `mark` `mark` int(2) unsigned NOT NULL default '0'";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$arrIndexes = $objDatabase->MetaIndexes(DBPREFIX."module_gallery_language");
	if ($arrIndexes !== false) {
		if (!isset($arrIndexes['galleryindex'])) {
			$query = "ALTER TABLE `".DBPREFIX."module_gallery_language` ADD FULLTEXT `galleryindex` (`value`)";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}

	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_gallery_language'));
		return false;
	}

	$arrIndexes = $objDatabase->MetaIndexes(DBPREFIX."module_gallery_language_pics");
	if ($arrIndexes !== false) {
		if (!isset($arrIndexes['galleryindex'])) {
				$query = "ALTER TABLE `".DBPREFIX."module_gallery_language_pics` ADD FULLTEXT `galleryindex` (`name` ,`desc`)";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}

	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_gallery_language_pics'));
		return false;
	}

	$arrGallerySettings = array(
		'paging'		=> '30',
		'show_latest'	=> 'on',
		'show_random'	=> 'on',
        // Added by Reto
        'header_type'   => 'hierarchy',
        'show_ext'      => 'on',
	);
	foreach ($arrGallerySettings as $name => $value) {
		$query = "SELECT id FROM `".DBPREFIX."module_gallery_settings` WHERE `name`='".$name."'";
		if (($objSettings = $objDatabase->Execute($query)) !== false) {
			if ($objSettings->RecordCount() == 0) {
				$query = "INSERT INTO `".DBPREFIX."module_gallery_settings` ( `name` , `value` ) VALUES ('".$name."', '".$value."')";
				if ($objDatabase->Execute($query) === false) {
					return _databaseError($query, $objDatabase->ErrorMsg());
				}
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	// add gallery detail page to main gallery page
	$arrModules = array();
	$query = "SELECT `id` FROM `".DBPREFIX."modules` WHERE `name`='gallery'";
	$objResult = $objDatabase->SelectLimit($query, 1);
	if ($objResult !== false) {
		if ($objResult->RecordCount() == 1) {
			$moduleId = $objResult->fields['id'];
		} else {
			setUpdateMsg(sprintf($_ARRAYLANG['TXT_MODULE_ENTRY_IS_MISSING'], 'gallery'));
			return false;
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	// get detail page
	$query = "
		SELECT
    		c.`id`,
    		c.`content`,
    		c.`title`,
    		c.`metatitle`,
    		c.`metadesc`,
    		c.`metakeys`,
    		c.`metarobots`,
    		c.`css_name`,
    		c.`redirect`,
    		c.`expertmode`,
    		n.`catid`,
    		n.`parcat`,
    		n.`catname`,
    		n.`target`,
    		n.`displayorder`,
    		n.`displaystatus`,
    		n.`cachingstatus`,
    		n.`cmd`,
    		n.`lang`,
    		n.`module`,
    		n.`startdate`,
    		n.`enddate`,
    		n.`protected`,
    		n.`frontend_access_id`,
    		n.`backend_access_id`,
    		n.`themes_id`
		FROM `".DBPREFIX."content` AS c
		INNER JOIN `".DBPREFIX."content_navigation` AS n ON n.`catid` = c.`id`
		WHERE n.`module`=".$moduleId." AND n.`cmd`='details'";
	$objDetailContent = $objDatabase->Execute($query);
	if ($objDetailContent !== false) {
		while (!$objDetailContent->EOF) {
    		$query = "
	    		SELECT
		    		c.`id`,
		    		c.`content`,
		    		c.`title`,
		    		c.`metatitle`,
		    		c.`metadesc`,
		    		c.`metakeys`,
		    		c.`metarobots`,
		    		c.`css_name`,
		    		c.`redirect`,
		    		c.`expertmode`,
		    		n.`catid`,
		    		n.`parcat`,
		    		n.`catname`,
		    		n.`target`,
		    		n.`displayorder`,
		    		n.`displaystatus`,
		    		n.`cachingstatus`,
		    		n.`cmd`,
		    		n.`lang`,
		    		n.`module`,
		    		n.`startdate`,
		    		n.`enddate`,
		    		n.`protected`,
		    		n.`frontend_access_id`,
		    		n.`backend_access_id`,
		    		n.`themes_id`
	    		FROM `".DBPREFIX."content` AS c
	    		INNER JOIN `".DBPREFIX."content_navigation` AS n ON n.`catid` = c.`id`
	    		WHERE n.`module`=".$moduleId." AND n.`cmd`='' AND n.`lang`=".$objDetailContent->fields['lang']." AND c.`content` NOT REGEXP '<\!--[[:space:]]+(BEGIN|END)[[:space:]]+galleryImage[[:space:]]+-->'";
    		$objContent = $objDatabase->SelectLimit($query, 1);
    		if ($objContent !== false) {
				if ($objContent->RecordCount() == 1) {
					$content = preg_replace('#<!--\s+(BEGIN|END)\s+galleryCategories\s+-->#', '<!-- \1 galleryCategoryList -->', $objContent->fields['content']);
					$content = '<!-- BEGIN galleryCategories -->'.$content.'<!-- END galleryCategories -->';
					$content .= '<!-- BEGIN galleryImage -->'.$objDetailContent->fields['content'].'<!-- END galleryImage -->';

					$query = "UPDATE `".DBPREFIX."content` AS c INNER JOIN `".DBPREFIX."content_navigation` AS n ON n.`catid` = c.`id`
		    			SET
		    				c.`content` = '".addslashes($content)."',
		    				n.`username` = 'sys_update',
		    				n.`changelog` = ".time()."
		    			WHERE
		    				c.`id` = ".$objContent->fields['id'];

					if ($objDatabase->Execute($query) !== false) {
						$objDatabase->Execute("UPDATE `".DBPREFIX."content_navigation_history` SET `is_active` = '0' WHERE `catid` = ".$objContent->fields['id']);
		    			$objDatabase->Execute("
		    				INSERT INTO `".DBPREFIX."content_navigation_history`
							SET
								`is_active` = '1',
								`catid` = ".$objContent->fields['id'].",
								`parcat` = ".$objContent->fields['parcat'].",
								`catname` = '".addslashes($objContent->fields['catname'])."',
								`target` = '".$objContent->fields['target']."',
								`displayorder` = ".$objContent->fields['displayorder'].",
								`displaystatus` = '".$objContent->fields['displaystatus']."',
								`cachingstatus` = '".$objContent->fields['cachingstatus']."',
								`username` = 'sys_update',
								`changelog` = ".time().",
								`cmd` = '".$objContent->fields['cmd']."',
								`lang` = ".$objContent->fields['lang'].",
								`module` = ".$objContent->fields['module'].",
								`startdate` = '".$objContent->fields['startdate']."',
								`enddate` = '".$objContent->fields['enddate']."',
								`protected` = ".$objContent->fields['protected'].",
								`frontend_access_id` = ".$objContent->fields['frontend_access_id'].",
								`backend_access_id` = ".$objContent->fields['backend_access_id'].",
								`themes_id` = ".$objContent->fields['themes_id']
						);

						$historyId = $objDatabase->Insert_ID();

						$objDatabase->Execute("
							INSERT INTO `".DBPREFIX."content_history`
							SET
								`id` = ".$historyId.",
								`page_id` = ".$objContent->fields['id'].",
								`content` = '".addslashes($content)."',
								`title` = '".addslashes($objContent->fields['title'])."',
								`metatitle` = '".addslashes($objContent->fields['metatitle'])."',
								`metadesc` = '".addslashes($objContent->fields['metadesc'])."',
								`metakeys` = '".addslashes($objContent->fields['metakeys'])."',
								`metarobots` = '".addslashes($objContent->fields['metarobots'])."',
								`css_name` = '".addslashes($objContent->fields['css_name'])."',
								`redirect` = '".addslashes($objContent->fields['redirect'])."',
								`expertmode` = '".$objContent->fields['expertmode']."'
						");

						$objDatabase->Execute("
							INSERT INTO	`".DBPREFIX."content_logfile`
							SET
								`action` = 'update',
								`history_id` = ".$historyId.",
								`is_validated` = '1'
						");
					} else {
						return _databaseError($query, $objDatabase->ErrorMsg());
					}
				}
    		} else {
    			return _databaseError($query, $objDatabase->ErrorMsg());
    		}
    		$objDetailContent->MoveNext();
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}


	return true;
}
?>